VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Navigate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal cbSize As Long)

Private Const POINT_END& = 0&
Private Const POINT_START& = &HFFFFFFF

Private Const PASS_TRUE& = &HFFFF00
Private Const PASS_FALSE& = &HFFFFFF
    
Private Enum CONST_DIRECTION
    [_D_NONE]
    D_UP& = 1&
    D_LEFT& = 2&
    D_RIGHT& = 4&
    D_DOWN& = 8&
    D_UL& = D_UP Or D_LEFT
    D_UR& = D_UP Or D_RIGHT
    D_DL& = D_DOWN Or D_LEFT
    D_DR& = D_DOWN Or D_RIGHT
End Enum

Private m_dFlags(0& To 7&) As CONST_DIRECTION
Private m_lOffset&(0& To 7&)

Private m_lpMap&(0& To 65535), _
        m_lpMapTmp&(0& To 65535)

Private m_nWave&
Private m_aWavePoint&(0& To 1023&), m_nWavePoints&

Private m_lWidth&, m_lHeight&
Private m_bInit&

Public Function Map_FindPath(ByRef lpPath() As Long, _
                             ByVal lStart As Long, _
                             ByVal lEnd As Long, _
                    Optional ByVal nWaveCount As Long) As Long
    If (m_bInit = False) Then Exit Function

    CopyMemory m_lpMapTmp(0&), m_lpMap(0&), m_lWidth * m_lHeight * 4&

    m_lpMapTmp(lStart) = POINT_START
    m_lpMapTmp(lEnd) = POINT_END

    m_aWavePoint(0&) = lEnd
    m_nWavePoints = 1&

    If (nWaveCount <= 0& Or nWaveCount > &HFFFF&) Then nWaveCount = &HFFFF&

    For m_nWave = 1& To nWaveCount
        If (Wave_Generate()) Then Exit For
        If (m_nWavePoints = 0&) Then Exit Function
    Next

    If (m_nWave > nWaveCount) Then
        Map_FindPath = -1&
        Exit Function
    End If

    ReDim lpPath&(0& To m_nWave - 1&)

    Dim lPoint&
    lPoint = lStart

    Dim i&, k&
    Dim dflags As CONST_DIRECTION
    Dim lMin&, lOffset&
    Dim Tmp&

    For i = 0& To m_nWave - 1&
        dflags = 0&

        lMin = lPoint
        Tmp = m_lpMapTmp(lMin)

        For k = 0& To 3&
            If (Tmp < PASS_TRUE) Then
                dflags = dflags Or m_dFlags(k)

                lOffset = lPoint + m_lOffset(k)

                If (Tmp > m_lpMapTmp(lOffset)) Then
                    lMin = lOffset
                    Tmp = m_lpMapTmp(lMin)
                End If
            End If
        Next

        For k = 4& To 7&
            If (dflags And m_dFlags(k)) Then
                lOffset = lPoint + m_lOffset(k)

                If (Tmp > m_lpMapTmp(lOffset)) Then
                    lMin = lOffset
                    Tmp = m_lpMapTmp(lMin)
                End If
            End If
        Next

        lPoint = lMin
        lpPath(i) = lPoint
    Next

    Map_FindPath = m_nWave
End Function

Public Function Map_Initialize(ByRef lpMap() As Byte, _
                               ByVal nWidth As Long, _
                               ByVal nHeight As Long) As Long
    If (((nWidth Or nHeight) > 256&) Or ((nWidth Or nHeight) < 16&)) Then
        Map_Initialize = -1&
        Exit Function
    End If

    m_lWidth = nWidth
    m_lHeight = nHeight

    m_lOffset(0&) = -m_lWidth
    m_lOffset(1&) = -1&
    m_lOffset(2&) = 1&
    m_lOffset(3&) = m_lWidth
    m_lOffset(4&) = -m_lWidth - 1&
    m_lOffset(5&) = -m_lWidth + 1&
    m_lOffset(6&) = m_lWidth - 1&
    m_lOffset(7&) = m_lWidth + 1&

    Dim i&
    For i = 0& To m_lHeight * m_lWidth - 1&
        m_lpMap(i) = PASS_FALSE - lpMap(i)
    Next

    m_bInit = True
End Function

Private Function Wave_Generate() As Long
    Dim i&, k&
    Dim dflags As CONST_DIRECTION
    Dim aWavePoint&(0& To 1023&), nWavePoints&
    Dim lpWavePoint&, lpOffset&
    Dim Tmp&, nWave&, bQuit&

    nWave = m_nWave * &HFF&

    For i = 0& To m_nWavePoints - 1&
        dflags = 0&

        lpWavePoint = m_aWavePoint(i)

        For k = 0& To 3&
            lpOffset = lpWavePoint + m_lOffset(k)
            Tmp = m_lpMapTmp(lpOffset)

            If (Tmp >= PASS_TRUE And Tmp < PASS_FALSE) Then
                m_lpMapTmp(lpOffset) = nWave + (Tmp - PASS_TRUE)

                aWavePoint(nWavePoints) = lpOffset
                nWavePoints = nWavePoints + 1&

                dflags = dflags Or m_dFlags(k)
            ElseIf (Tmp < nWave) Then
                dflags = dflags Or m_dFlags(k)
            ElseIf (Tmp = POINT_START) Then
                m_lpMapTmp(lpOffset) = nWave + &HFF&

                bQuit = True
                Exit For
            End If
        Next

        If (bQuit) Then Exit For

        For k = k To 7&
            lpOffset = lpWavePoint + m_lOffset(k)
            Tmp = m_lpMapTmp(lpOffset)
            
            If (dflags And m_dFlags(k)) Then
                If (Tmp >= PASS_TRUE And Tmp < PASS_FALSE) Then
                    m_lpMapTmp(lpOffset) = nWave + Tmp - PASS_TRUE

                    aWavePoint(nWavePoints) = lpOffset
                    nWavePoints = nWavePoints + 1&
                ElseIf (Tmp = POINT_START) Then
                    m_lpMapTmp(lpOffset) = nWave + &HFF&

                    bQuit = True
                    Exit For
                End If
            End If
        Next

        If (bQuit) Then Exit For
    Next

    CopyMemory m_aWavePoint(0&), aWavePoint(0&), nWavePoints * 4&
    m_nWavePoints = nWavePoints

    If (bQuit) Then Wave_Generate = True
End Function

Private Sub Class_Initialize()
    m_dFlags(0&) = D_UP
    m_dFlags(1&) = D_LEFT
    m_dFlags(2&) = D_RIGHT
    m_dFlags(3&) = D_DOWN
    m_dFlags(4&) = D_UL
    m_dFlags(5&) = D_UR
    m_dFlags(6&) = D_DL
    m_dFlags(7&) = D_DR
End Sub

Private Sub Class_Terminate()
    Erase m_dFlags()
    Erase m_lOffset()

    Erase m_lpMap()
    Erase m_lpMapTmp()

    m_nWave = 0&

    Erase m_aWavePoint()
    m_nWavePoints = 0&

    m_lWidth = 0&
    m_lHeight = 0&

    m_bInit = 0&
End Sub
